import { IObservableStorage } from '../../interfaces/IObservableStorage';
import { ISerializable } from '../../interfaces/ISerializable';
import { ISerialized } from '../../interfaces/ISerialized';
import { IStorage } from '../../interfaces/IStorage';
import { Serializer } from '../../utils/Serializer';
import { AbstractBrowserHistoryStorage } from './AbstractBrowserHistoryStorage';
import { IBrowserHistoryStorageOptions } from './IBrowserHistoryStorageOptions';
export declare class BrowserHistoryUrlStorage<TValue extends ISerializable> extends AbstractBrowserHistoryStorage<TValue> implements IObservableStorage<TValue> {
    readonly decodeUrl: (url: URL) => TValue;
    readonly encodeUrl: (params: TValue) => URL;
    constructor(decodeUrl: (url: URL) => TValue, encodeUrl: (params: TValue) => URL, defaultValue: TValue, options?: Partial<IBrowserHistoryStorageOptions>, storage?: IStorage<ISerialized>, serializer?: Serializer<TValue>);
}
